clear all; close all;

%   audioSampleLocation = '../organised_samples/single_note/Jazz Guitar/'; %only first 46 valid
%   audioSampleLocation = '../organised_samples/single_note/Reactor Strat Samples F/';
%   audioSampleLocation = '../organised_samples/single_note/Reactor Strat Samples MP fretted/';
%   audioSampleLocation = '../organised_samples/single_note/ClassicFree/testing/';


%    audioSampleLocation =  '../organised_samples/single_note/E-Guitar Bridge-Pickup Samples/';
%     audioSampleLocation = '../organised_samples/single_note/Elektrik Guitar Samples/testingSet/';
%     audioSampleLocation = '../organised_samples/single_note/Funk Guitar Samples/';
%     audioSampleLocation = '../organised_samples/single_note/Harmonic Guitar Samples/';


files = dir(strcat(audioSampleLocation,'*.wav'));
files2 = struct;
files2 = removeByRegEx('L[1-3]', files2, files);
files = files2';


% Inharmonicity coefficients for a metal G string
d  = 0.46; % diameter       in mm
ym = 200;  % youngsModulus  in GPa
l  = 610;  % length         in mm
t  = 8.43; % tension        in Kg

maxIn     = inharmonicity(1.2446,610,l,8.6); %start value, low notes low string
minIn     = inharmonicity(0.270,305,l,8.9);  %end value, high notes high string
decrement = (maxIn - minIn)/length(files);

frequencyArray = zeros(1,length(files));
MArray = zeros(1,length(files));

i = 1;
inharmonicityCoefficient = maxIn;
for file = files'
%     soundsc(audioread(strcat(audioSampleLocation,file.name)),44100);
%     combFilterOutput  = icf(inharmonicityCoefficient ,strcat(audioSampleLocation,file.name));
    [FinalF0Est, FinalBEst, featureVector, M]  = icf(inharmonicity(d,ym,l,t) ,strcat(audioSampleLocation,file.name));
    frequencyArray(i) = FinalF0Est;
    MArray(i) = M;
    
    inharmonicityCoefficient = inharmonicityCoefficient - decrement;
    i = i + 1;
end

plot(frequencyArray)