%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% Finds the possible string and fret positions for a give guitar note
% within a two percent tolerance
% 
% Input(s): A note frequency
%            
% Output(s): The possible positions (below fret 12) on a guitar
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function output = findPossibleNotePositions(frequency)

output = [];

GuitarNeck = [82.41 87.31 92.50 98.00 103.8 110.0 116.5 123.5 130.8 138.6 146.8 155.6 164.8;
			  110.0 116.5 123.5 130.8 138.6 146.8 155.6 164.8 174.6 185.0 196.0 207.7 220.0;
			  146.8 155.6 164.8 174.6 185.0 196.0 207.7 220.0 233.1 246.9 261.6 277.2 293.7;
			  196.0 207.7 220.0 233.1 246.9 261.6 277.2 293.7 311.1 329.6 349.2 370.0 392.0;
			  246.9 261.6 277.2 293.7 311.1 329.6 349.2 370.0 392.0 415.3 440.0 466.2 493.9;
			  329.6 349.2 370.0 392.0 415.3 440.0 466.2 493.9 523.3 554.4 587.3 622.3 659.3];
          
          
sizeOfGuitar = size(GuitarNeck);
k = 1;
    j = 1;
    while j <= sizeOfGuitar(1)
        i = 1;
        while i <= sizeOfGuitar(2)
            if frequency >= GuitarNeck(j,i)*0.98 && frequency <= GuitarNeck(j,i)*1.02
                output(k,1) = j;
                output(k,2) = i;
                k = k + 1;
            end
            i = i + 1;
        end
        j = j + 1;
    end

end

