%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Scales an input vector to a maximum given value
% 
% Input(s):  A row vector (of FFT data)
%            A maximum value for the array
% 
% Output(s): A vector scaled to the maximum value
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function output = normalise(inputData,scalingValue)

    maxValue = max(inputData);
    output   = inputData./maxValue*scalingValue;

end