%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% This function compares the similarity of two identically sized
% matrices and returns a precentage value of rows that are exactly
% equal.
%
% Input(s): A matrix of predicted string and fret values
%           (column 1 is the string and column 2 is the fret). 
%           A matrix containing the actual known value for
%           predicted data. Must be the same structure as the
%           predicted values matrix.
%          
%          
% Output(s): Percentage of rows that are the same.
%          
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function output = precentageSimilarity(actualFretValues, predictedFretValues)
    correctnessValues = zeros(1,length(predictedFretValues));
    
    for i = 1:length(predictedFretValues)
        if predictedFretValues(i,:) == actualFretValues(i,:)
            correctnessValues(i) = 1;
        else
            correctnessValues(i) = 0;
        end
    end

    output = (sum(correctnessValues)/length(correctnessValues))*100;
end