%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% Reads an audio file and converts it to mono if it is comprised of more
% than one channel.
% *NOTE* This funtion should replace audioread in all cases as stereo files
% are not usable in the analysis.
%
% Input(s): Mono or stereo audio file                     
%                  
% Output(s): Mono audio file
%          
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [audio, sampleRate] = readAudioMono(inputData)

    [audio, sampleRate] = audioread(inputData);

    [x, y] = size(audio);
    
    if y == 2
        audio = (audio(:,1)+audio(:,2))/2 ; % Channels averaged to create mono output.
    elseif y > 2
        error(['Error: File contains more than two channels of audio'...
        'or the matrix has been setup incorrectly and needs roation'...
        '(must be n*1 matrix).']);
    end

end