clear all; close all;

  option     = 1; % choice of string (1 being lowest, 6 being highest)

 totalEnergytot      = zeros(6,13);
 bestArr          = zeros(6,13);
 
%   for option = 1:6
    stringOpts     = {'E' 'A' 'D' 'G' 'B' 'E high'};
    files          = '../organised_samples/single_note/Stef_Short_Stab_Plectrum/';
    notesPerString = 13;

    icfBinOffset    = 0.05;
    stringDiameters = [0.25 0.33 0.43 0.76 1.066 1.3208]; 
    stringTensions  = [7.36 6.98 7.52 11.22 11.61 9.59]; 
    
    GuitarNeck      = [82.41 87.31 92.50 98.00 103.8 110.0 116.5 123.5 130.8 138.6 146.8 155.6 164.8;
                       110.0 116.5 123.5 130.8 138.6 146.8 155.6 164.8 174.6 185.0 196.0 207.7 220.0;
                       146.8 155.6 164.8 174.6 185.0 196.0 207.7 220.0 233.1 246.9 261.6 277.2 293.7;
                       196.0 207.7 220.0 233.1 246.9 261.6 277.2 293.7 311.1 329.6 349.2 370.0 392.0;
                       246.9 261.6 277.2 293.7 311.1 329.6 349.2 370.0 392.0 415.3 440.0 466.2 493.9;
                       329.6 349.2 370.0 392.0 415.3 440.0 466.2 493.9 523.3 554.4 587.3 622.3 659.3]; % note frequencies in Hz         

    desiredFeatureVecotrLength = 30;

%     d = stringDiameters(option);  % string diameter in mm
%     t = stringTensions(option);   % string tension  in Kg
    d = mean(stringDiameters);
    t = mean(stringTensions);
    ym = 200;                     % youngsModulus   in GPa

    predictedBEst    = zeros(1,13); % predicted inharmonicity value per fret for comparison
    festArr          = zeros(1,13);
    
    MArr             = zeros(1,13);
    featureVectorArr = zeros(13,desiredFeatureVecotrLength);
    totalEnergy      = zeros(1,13);


    for i = 0:12
    %     l = calcFrettedStringLength(610,i); % string length from played fret in mm
        l = calcFrettedStringLength(610,0); % string length from played fret in mm
        predictedBEst(i+1) = inharmonicity(d,ym,l,t); 

        sample = strcat(files, char(stringOpts(option)), {' '} ,int2str(i), '.wav');
        [FinalF0Est, FinalBEst, featureVector, M] = icf(predictedBEst(i+1), sample{1}, icfBinOffset);

        if length(featureVector) < desiredFeatureVecotrLength
            featureVector = padWithZeros(featureVector, desiredFeatureVecotrLength);
        end

        featureVectorArr(i+1,:) = normalise(featureVector,1);
        MArr(i+1)               = M;
        festArr(i+1)            = FinalF0Est;
        bestArr(option,i+1)     = FinalBEst;
    end

    for i = 1:13
        totalEnergy(i) = sum(featureVectorArr(i,:));
    end

    predictedFretValues = zeros(13,2);

    for i = 1:13
        possibleNeckPositions = findPossibleNotePositions(festArr(i));

        estimateFretPossibilities = linspace(2,1,13);

        val = totalEnergy(i);
        tmp = abs(estimateFretPossibilities - val);
        [idx idx] = min(tmp);
        predictedFretPosition = idx; %closest value in to match on neck

        tmp = abs(possibleNeckPositions(:,2)' - predictedFretPosition);
        [idx idx] = min(tmp);

        predictedFretValues(i,1) = possibleNeckPositions(idx,1);
        predictedFretValues(i,2) = possibleNeckPositions(idx,2);
    end

    totalEnergytot(option,:) = totalEnergy;
    
    actualFretValues = cat(1,ones(1,length(predictedFretValues))*option,[1:length(predictedFretValues)])';
    percentageAccuracy = precentageSimilarity(actualFretValues,predictedFretValues);

%  end


figure;
% plot(0:12,predictedFretValues);
% xlabel('Fret number');
% ylabel('Predicted fret');
% title('Fret number prediction');
% 
% legend('Measured inharmonicity','Predicted inharmonicity');
% 
% subplot(3,2,1)
% plot(0:12, GuitarNeck(option,:)./festArr,'k');
% axis([0 12 0 2])
% xlabel('Fret number');
% ylabel('Actual frequency divided by predicted frequency');
% title('Frequency estimates for an A string of an electric guitar');
% 
% subplot(3,2,2)
% hold on;
% plot(0:12,bestArr,'r');
% plot(0:12,predictedBEst,'g');
% xlabel('Fret number');
% ylabel('Inharmonicity coefficient');
% title('Inharmonicity estimates for an A string of an electric guitar');
% 
% subplot(3,2,3)
hold on;
plot(0:12,MArr,'b');
axis([0 12 0 30])
xlabel('Fret number');
ylabel('Number of iterations');
% 
% subplot(3,2,4)


% C = {'k','b','r','g','y','m'};
% 
% hold all;
% for i = 1:6
%     plot(0:12, bestArr(i,:),char(C(i)));
% end
% 
% xlabel('Fret number');
% ylabel('Measured inharmonicity');
% 
% legend('E2', 'A2', 'D3', 'G3', 'B3', 'E4')

% totenergyAvg = zeros(1,13);
% for i = 1:13
%     totenergyAvg(i) = mean(totalEnergytot(:,i));
% end
% 
% hold all;
% for i = 1:6
%     plot(0:12, totalEnergytot(i,:));
% end
% 
% plot(0:12, totenergyAvg, 'LineWidth', 2);
% 
% legend('E (low) string','A string','D string','G string','B string','E (high) string','Average energy');
% axis([0 12 0 3])
% xlabel('Fret number');
% ylabel('Total energy in bins');

% subplot(3,2,5)
% bar3(featureVectorArr);
% colorbar
% xlabel('Bin number');
% ylabel('Fret number');
% zlabel('Normalised energy in bins')
