clear all; close all;

format long g;

directorysToClassify = {
     '../organised_samples/single_note/E-Guitar Bridge-Pickup Samples/'
     '../organised_samples/single_note/Elektrik Guitar Samples/testingSet/'
     '../organised_samples/single_note/Funk Guitar Samples/'
     '../organised_samples/single_note/Nylon Guitar Samples/'
    };

testingSetSize = 0.2;  % Portion of the directory to be used for testing

histBinNum = 10000;
histThresh = 0.1;

icfBinOffset    = 0.05;
stringDiameters = [0.25 0.33 0.43 0.76 1.066 1.3208]; 
stringTensions  = [7.36 6.98 7.52 11.22 11.61 9.59];
d  = mean(stringDiameters);
ym = 200;
t  = mean(stringTensions);
l = calcFrettedStringLength(610,0);
bestIn = inharmonicity(d,ym,l,t); 

numberOfFiles  = 0;
for audioSampleLocation = directorysToClassify'
    samp = strcat(char(audioSampleLocation),'*.wav');
    files = dir(samp);
    fwIT  = struct;
    fwIT = removeByRegEx('L[1-3]', fwIT, files);
    [x,y] = size(fwIT);
    numberOfFiles = numberOfFiles + x;
end

numberOfTests = numberOfFiles - floor(numberOfFiles*(1-testingSetSize));
numberOfTrain = numberOfFiles - numberOfTests;

testingLabels  = zeros(1,numberOfTests);
trainingLabels = zeros(1,numberOfTrain);

% testingMatrix  = zeros(numberOfTests,(histBinNum/2)-1);
% trainingMatrix = zeros(numberOfTrain,(histBinNum/2)-1);

testingMatrix  = zeros(numberOfTests,30);
trainingMatrix = zeros(numberOfTrain,30);

testingMatrix2  = zeros(numberOfTests,1);
trainingMatrix2 = zeros(numberOfTrain,1);

i = 1; j = 1;
for samples = directorysToClassify'
    
    audioSampleLocation  = char(samples);    
    files = dir(strcat(audioSampleLocation,'*.wav'));
    
    testingArray            = struct;
    filesWithIntensityTags  = struct;
    
    filesWithIntensityTags = removeByRegEx('L[1-3]', filesWithIntensityTags, files);
    [testingArray, filesWithIntensityTags] = createTestingSet(testingSetSize, testingArray, filesWithIntensityTags);
%     testingArray = testingArray';
     filesWithIntensityTags = filesWithIntensityTags';
    
    for file = filesWithIntensityTags'
        classificationLabel = getClassificationLabel(file.name,'L[1-3]');
        [FreqEst, BEst, featureVector, M]  = icf(bestIn, strcat(audioSampleLocation,file.name),0.1);
        trainingMatrix(i,:) = padWithZeros(normalise(featureVector,1),30);
        trainingMatrix2(i)  = sum(normalise(featureVector,1));
        trainingLabels(i)   = classificationLabel;     
        i = i + 1;
    end
    
    for file = testingArray'
        classificationLabel = getClassificationLabel(file.name,'L[1-3]');        
        [FreqEst, BEst, featureVector, M]  = icf(bestIn, strcat(audioSampleLocation,file.name),0.1);
        testingMatrix(j,:) = padWithZeros(normalise(featureVector,1),30);
        testingMatrix2(j)  = sum(normalise(featureVector,1));
        testingLabels(j)   = classificationLabel;
        
        j = j + 1;
    end
end

libsvmwrite('../dataFiles/train_fv.txt', trainingLabels', sparse(trainingMatrix));
libsvmwrite('../dataFiles/test_fv.txt', testingLabels', sparse(testingMatrix));
     
libsvmwrite('../dataFiles/train_ths.txt', trainingLabels', sparse(trainingMatrix2));
libsvmwrite('../dataFiles/test_ths.txt', testingLabels, sparse(testingMatrix2));
